//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2
#property indicator_level1  0.0

//
//
//    fft library made by klot
//
//

#import "#_lib_FFT.ex4"
   void realfastfouriertransform(double& a[], int tnn, bool inversefft);
#import

//
//
//
//
//

extern int Price            = PRICE_CLOSE;
extern int Window           = 256;
extern int FilterBellow     =   2;
extern int FilterAbove      =  50;
extern int StartDrawingFrom = 250;

//
//
//
//
//

double fft[];
double values[];
double calcValues[];
int    initialSize;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,fft);
      SetIndexBuffer(1,values);
      
      //
      //
      //
      //
      //
      
      int n           = NormalizeDouble(MathLog(Window)/MathLog(2),0);
          initialSize = MathMax(MathPow(2,n),16);
          ArrayResize(calcValues,initialSize);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;   
           limit=MathMin(Bars-counted_bars,Bars-1);

   
   //
   //
   //
   //
   //
   
      for(i=limit; i>=0; i--)
      {
         values[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         
         //
         //
         //
         //
         //
         
         if (i<=StartDrawingFrom)
         {
            int calcSize = initialSize;
            if (calcSize>Bars)
            {
               int n        = NormalizeDouble(MathLog(Bars)/MathLog(2),0);
                   calcSize = MathMax(MathPow(2,n),16);
                      if (calcSize>Bars) calcSize = MathMax(MathPow(2,n-1),16);
            }      
            if (calcSize>Bars)     break;
            if ((Bars-i)<calcSize) continue;
            if (ArraySize(calcValues) != calcSize) ArrayResize(calcValues,calcSize);
                ArrayCopy(calcValues,values,0,i,calcSize);

            //
            //
            //
            //
            //
            
            realfastfouriertransform(calcValues,calcSize,false);
               for(int k=0; k<calcSize; k++) if (k<FilterBellow || k>FilterAbove) calcValues[k]=0.0;
            realfastfouriertransform(calcValues,calcSize,true);
            fft[i] = calcValues[0];
         }                   
      }         

   //
   //
   //
   //
   //
      
   SetIndexDrawBegin(0,Bars-StartDrawingFrom);
   return(0);
}